require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ELF_H_)) {
    eval 'sub _MACHINE_ELF_H_ () {1;}' unless defined(&_MACHINE_ELF_H_);
    require 'sys/elf32.ph';
    eval 'sub __ELF_WORD_SIZE () {32;}' unless defined(&__ELF_WORD_SIZE);
    require 'sys/elf_generic.ph';
    eval 'sub ELF_ARCH () { &EM_ARM;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_MACHINE_OK {
        my($x) = @_;
	    eval q((($x) ==  &EM_ARM));
    }' unless defined(&ELF_MACHINE_OK);
    eval 'sub R_ARM_COUNT () {33;}' unless defined(&R_ARM_COUNT);
    eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
    if(defined(&__ARMEB__)) {
	eval 'sub ELF_TARG_DATA () { &ELFDATA2MSB;}' unless defined(&ELF_TARG_DATA);
    } else {
	eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
    }
    eval 'sub ELF_TARG_MACH () { &EM_ARM;}' unless defined(&ELF_TARG_MACH);
    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
    eval 'sub EF_ARM_EABI_VERSION {
        my($x) = @_;
	    eval q(((($x) &  &EF_ARM_EABIMASK) >> 24));
    }' unless defined(&EF_ARM_EABI_VERSION);
    eval 'sub EF_ARM_EABI_VERSION_UNKNOWN () {0;}' unless defined(&EF_ARM_EABI_VERSION_UNKNOWN);
    eval 'sub EF_ARM_EABI_FREEBSD_MIN () {4;}' unless defined(&EF_ARM_EABI_FREEBSD_MIN);
    eval 'sub ET_DYN_LOAD_ADDR () {0x1001000;}' unless defined(&ET_DYN_LOAD_ADDR);
    eval 'sub HWCAP_SWP () {0x1;}' unless defined(&HWCAP_SWP);
    eval 'sub HWCAP_HALF () {0x2;}' unless defined(&HWCAP_HALF);
    eval 'sub HWCAP_THUMB () {0x4;}' unless defined(&HWCAP_THUMB);
    eval 'sub HWCAP_26BIT () {0x8;}' unless defined(&HWCAP_26BIT);
    eval 'sub HWCAP_FAST_MULT () {0x10;}' unless defined(&HWCAP_FAST_MULT);
    eval 'sub HWCAP_FPA () {0x20;}' unless defined(&HWCAP_FPA);
    eval 'sub HWCAP_VFP () {0x40;}' unless defined(&HWCAP_VFP);
    eval 'sub HWCAP_EDSP () {0x80;}' unless defined(&HWCAP_EDSP);
    eval 'sub HWCAP_JAVA () {0x100;}' unless defined(&HWCAP_JAVA);
    eval 'sub HWCAP_IWMMXT () {0x200;}' unless defined(&HWCAP_IWMMXT);
    eval 'sub HWCAP_CRUNCH () {0x400;}' unless defined(&HWCAP_CRUNCH);
    eval 'sub HWCAP_THUMBEE () {0x800;}' unless defined(&HWCAP_THUMBEE);
    eval 'sub HWCAP_NEON () {0x1000;}' unless defined(&HWCAP_NEON);
    eval 'sub HWCAP_VFPv3 () {0x2000;}' unless defined(&HWCAP_VFPv3);
    eval 'sub HWCAP_VFPv3D16 () {0x4000;}' unless defined(&HWCAP_VFPv3D16);
    eval 'sub HWCAP_TLS () {0x8000;}' unless defined(&HWCAP_TLS);
    eval 'sub HWCAP_VFPv4 () {0x10000;}' unless defined(&HWCAP_VFPv4);
    eval 'sub HWCAP_IDIVA () {0x20000;}' unless defined(&HWCAP_IDIVA);
    eval 'sub HWCAP_IDIVT () {0x40000;}' unless defined(&HWCAP_IDIVT);
    eval 'sub HWCAP_VFPD32 () {0x80000;}' unless defined(&HWCAP_VFPD32);
    eval 'sub HWCAP_IDIV () {( &HWCAP_IDIVA |  &HWCAP_IDIVT);}' unless defined(&HWCAP_IDIV);
    eval 'sub HWCAP_LPAE () {0x100000;}' unless defined(&HWCAP_LPAE);
    eval 'sub HWCAP_EVTSTRM () {0x200000;}' unless defined(&HWCAP_EVTSTRM);
    eval 'sub HWCAP2_AES () {0x1;}' unless defined(&HWCAP2_AES);
    eval 'sub HWCAP2_PMULL () {0x2;}' unless defined(&HWCAP2_PMULL);
    eval 'sub HWCAP2_SHA1 () {0x4;}' unless defined(&HWCAP2_SHA1);
    eval 'sub HWCAP2_SHA2 () {0x8;}' unless defined(&HWCAP2_SHA2);
    eval 'sub HWCAP2_CRC32 () {0x10;}' unless defined(&HWCAP2_CRC32);
}
1;
